import { ElementRef, EventEmitter, NgZone, Renderer } from '@angular/core';
import { Content } from '../content/content';
import { ItemReorderGesture } from '../item/item-reorder-gesture';
export declare class ReorderIndexes {
    from: number;
    to: number;
    constructor(from: number, to: number);
    applyTo(array: any): void;
}
export declare class ItemReorder {
    private _rendered;
    private _zone;
    private _content;
    _enableReorder: boolean;
    _visibleReorder: boolean;
    _reorderGesture: ItemReorderGesture;
    _lastToIndex: number;
    _element: HTMLElement;
    ionItemReorder: EventEmitter<ReorderIndexes>;
    constructor(elementRef: ElementRef, _rendered: Renderer, _zone: NgZone, _content: Content);
    ngOnDestroy(): void;
    reorder: boolean;
    _reorderPrepare(): void;
    _reorderStart(): void;
    _reorderEmit(fromIndex: number, toIndex: number): void;
    _scrollContent(scroll: number): number;
    _reorderReset(): void;
    _reorderMove(fromIndex: number, toIndex: number, itemHeight: number): void;
    setElementClass(classname: string, add: boolean): void;
    getNativeElement(): HTMLElement;
}
export declare class Reorder {
    private item;
    private elementRef;
    constructor(item: ItemReorder, elementRef: ElementRef);
    getReorderNode(): HTMLElement;
    onClick(ev: any): void;
}
export declare function findReorderItem(node: any, listNode: any): HTMLElement;
export declare function indexForItem(element: any): number;
export declare function reorderListForItem(element: any): any;
